#include <unistd.h>
#include <cstdlib>
#include <iostream>

#include <qpid/client/Connection.h>
#include <qpid/client/Session.h>
#include <qpid/client/Message.h>

using namespace qpid::client;
using namespace qpid::framing;

using std::string;


int 
main ( int argc, char** argv ) 
{
  const char* host = "127.0.0.1";
  int port = 5801;
  Connection connection;
  Message msg;

  connection.open ( host,port );
  Session session =  connection.newSession();


  std::cerr << "declare exchange\n";
  session.exchangeDeclare ( 
                            arg::exchange="my_exchange", 
                            arg::type="direct", 
                            arg::durable=false
                          );

  std::cerr << "declare exchange again\n";
  sleep ( 1 );
  session.exchangeDeclare ( 
                            arg::exchange="my_exchange", 
                            arg::type="direct", 
                            arg::durable=false
                          );

  std::cerr << "declare exchange again\n";
  sleep ( 1 );
  session.exchangeDeclare ( 
                            arg::exchange="my_exchange", 
                            arg::type="direct", 
                            arg::durable=false
                          );

  try 
  {
    for ( int count = 1; count <= 1000; ++ count )
    {
      char q_name[100];
      sprintf ( q_name, "q_%d", count );
      session.queueDeclare ( arg::queue=q_name,
                             arg::durable=false,
                             arg::autoDelete=true
                           );

      session.exchangeBind ( arg::exchange   = "my_exchange", 
                             arg::queue      = q_name, 
                             arg::bindingKey = q_name
                           );
      std::cerr << "Declared queue " << q_name << " .\n";
    }
  
    connection.close();
    return 0;
  } 
  catch ( const std::exception& error ) 
  {
    std::cout << error.what() << std::endl;
  }

  return 1;
}





